#include "CalcButton.h"

QCalcButton::QCalcButton(const QString &text, QWidget *parent, const CALC_OP opcode, const char *name) :
	QPushButton(text, parent, name)
{
	func_name = text;
	this->opcode = opcode;

	QObject::connect(this, SIGNAL( clicked() ), this, SLOT( doFunc() ));	
}


void QCalcButton::setFunc(const QString &text, const CALC_OP opcode)
{
	QPushButton::setText(text);

	func_name = text;
	this->opcode = opcode;
}


void QCalcButton::doFunc()
{
	emit funcName(func_name);
	emit funcOp(func_name, opcode);
}

