#ifndef __CALC_MEMORY_H
#define __CALC_MEMORY_H

#include "CalcObject.h"


#define MAX_VAR_NAME	4


class CCalcVariable
{
	public:
		CCalcVariable(const char *name, CCalcObject *object, CCalcVariable *prev);
		~CCalcVariable();

		void newObject(CCalcObject *object);

		CCalcVariable *next;
		CCalcVariable *prev;
		CCalcObject *object;

		char name[MAX_VAR_NAME +1];
};


class CCalcMemory
{
	public:
		CCalcMemory();
		~CCalcMemory();

		CCalcObject *stoVariable(const char *name, CCalcObject *object);
		CCalcObject *rclVariable(const char *name, CCalcObject *parent);
		CCalcObject *delVariable(const char *name, CCalcObject *parent);
		long getNumVars();
		const char *getVarName(long index=-1);
	
	protected:
		CCalcVariable *first;
		CCalcVariable *last;
		long numVars;
		long lastIndex;

		CCalcVariable *findVariable(const char *name);
};

#endif //__CALC_MEMORY_H

