#include "CalcObject.h"

#include <string.h>


OPCODE_TAB opcode_table[] =
{
	{	DUP,	"DUP"	},
	{	POP,	"POP"	},
	{	CLR,	"CLR"	},
	{	SWAP,	"SWAP"	},
	{	SWPN,	"SWPN"	},
	{	CHS,	"CHS"	},

	{	ADD,	"ADD"	},
	{	SUB,	"SUB"	},
	{	MUL,	"MUL"	},
	{	DIV,	"DIV"	},
	{	PWR,	"PWR"	},
	{	ROOT,	"ROOT"	},
	{	SQRT,	"SQRT"	},
	{	SQR,	"SQR"	},
	{	LOG,	"LOG"	},
	{	ALOG,	"ALOG"	},
	{	LN,		"LN"	},
	{	EXP,	"EXP"	},
	{	SIN,	"SIN"	},
	{	COS,	"COS"	},
	{	TAN,	"TAN"	},
	{	ASIN,	"ASIN"	},
	{	ACOS,	"ACOS"	},
	{	ATAN,	"ATAN"	},

	{	INT,	"INT"	},
	{	BSL,	"BSL"	},
	{	BSR,	"BSR"	},
	{	ASL,	"ASL"	},
	{	ASR,	"ASR"	},
	{	CMP,	"CMP"	},
	{	NOT,	"NOT"	},
	{	AND,	"AND"	},
	{	OR,		"OR"	},
	{	XOR,	"XOR"	},
	{	EQU,	"EQU"	},
	{	IDV,	"IDV"	},
	{	MOD,	"MOD"	},

	{	STO,	"STO"	},
	{	RCL,	"RCL"	},
	{	DIR,	"DIR"	},

	{	NOP,	"***"	}			// marks end of table
};

// Returns a string representation of the opcode
//
const char *getName(CALC_OP opcode)
{
	static char name[5];
	long i = 0;

	while ((opcode_table[i].opcode != NOP) && (opcode_table[i].opcode != opcode))
		i++;

	strncpy(name, opcode_table[i].name, 4);
	name[4] = 0;

	return name;
}


// Error message table
//
ERROR_STR error_string[] =
{
	//-------------------------------
	"*00: Invalid 2nd level object.",
	"*01: 2nd level object required.",
	"*02: Invalid 1st level object.",
	"*03: Syntax error.",
	"*04: 1st level object required.",
	"*05: Stack is empty.",
	"*06: Variable not found."
};

const char *getErrorMsg(long index)
{
	return (const char *)&error_string[index];
}


// Calculator modes
//
CALC_MODES mode;

// Error callback
//
void (*error_callback)(const char *msg);


CCalcObject::CCalcObject(CCalcObject *parent)
{
	type = UNKNOWN;
	next = (CCalcObject *)parent;
}


CCalcObject::~CCalcObject()
{

}


