#ifndef __CALC_STACK_H
#define __CALC_STACK_H

#include "CalcObject.h"
#include "CalcMemory.h"


extern CCalcMemory mem;

class CCalcStack
{
	public:

		CCalcStack(void (*error_fn)(void));
		~CCalcStack();
		void push(CCalcObject *object);
		void parseNewObject(const char *expression);
		const char &pop();
		void exec(CALC_OP opcode);

		CCalcObject *base;
		CALC_MODES *mode;

		static void callError(const char *);
		char *error_msg;

	protected:
		bool isIntegerDigit(const char digit);
		bool isFloatDigit(const char digit);
};


#endif //__CALC_STACK_H
