#ifndef __RPN_H
#define __RPN_H

#include "Calc.h"
#include "CalcButton.h"
#include <qlayout.h>
#include <qlistbox.h>
#include <qlineedit.h>
#include <qlabel.h>
#include <qpe/config.h>

typedef enum BUTTON_MODE
{
	MATH,
	BIN,
	MEM
};

class QCalcWindow : public QWidget
{
	Q_OBJECT

	public:

		QCalcWindow(QWidget *parent=0, const char *name=0, WFlags fl=0);
		~QCalcWindow();
		void setButtonMode(BUTTON_MODE mode);
		void updateStack();
		void updateMode();
		void updateVars();

		QListBox *stackList;
		QLineEdit *stackTop;
		QCalcButton *pButton[11];
		QCalcButton *vButton[5];
		QCalcButton *eButton;

		bool inverse;
		bool error;
		BUTTON_MODE mode;
		CCalcStack *stack;
		QLabel *annuncMode;
		long varIndex;

		static void error_callback(void);

	public slots:
		void modeButton(const QString &);
		void editButton(const QString &);
		void funcButton(const QString &, const CALC_OP opcode);
		void varButton(const QString &);
		void dirButton(const QString &);

	protected:
		void ReadConfig();
		void PurgeConfig();
		void WriteConfig();
		bool config_dirty;
		Config *CalcConfig;
};


#endif //__RPN_H

